package com.madeu.controller.mobile.mobilepush;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobilepush.MobilePushService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;


@Slf4j
@Controller
public class MobilePushController extends ManagerDraftAction{

	@Autowired
	private MobilePushService mobilePushService;

	/**
	 * 알림 리스트 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/mobilepush/selectListPushIntro.do")
	public String  selectListPushIntro(HttpSession session,HttpServletRequest request, Model model) {
		log.debug("MobilePushController  selectListPushIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return "/mobile/login/login";
			}else{
			}
		}catch(Exception e){
			e.printStackTrace();
			return "/mobile/login/login";
		}
		log.debug("MobilePushController  selectListPushIntro END");
		return "/mobile/push/pushSelectList";
	}

	/**
	 * 앱 푸시 정보 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilepush/selectListPush.do")
	public ModelAndView selectListPush(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
		log.debug("MobilePushController selectListPush START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}else{
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("deviceUuid", String.valueOf(session.getAttribute("mobileDeviceUuid")));
				map = mobilePushService.selectListPush(paramMap);
			}
		}catch(Exception e){
			e.printStackTrace();
			return null;
		}finally{
			if(Constants.OK == map.get("msgCode")) {

			}else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobilePushController selectListPush END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 앱 푸시 정보 상세 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilepush/selectPush.do")
	public ModelAndView selectPush(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
		log.debug("MobilePushController selectPush START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}else{
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobilePushService.selectPush(paramMap);
			}
		}catch(Exception e){
			e.printStackTrace();
			return null;
		}finally{
			if(Constants.OK == map.get("msgCode")) {

			}else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobilePushController selectPush END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 푸시 알림 갯수 체크
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilepush/selectPushCountCheck.do")
	public ModelAndView selectPushCountCheck(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
		log.debug("MobilePushController selectPushCountCheck START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}else{
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("deviceUuid", String.valueOf(session.getAttribute("mobileDeviceUuid")));
				map = mobilePushService.selectPushCountCheck(paramMap);
			}
		}catch(Exception e){
			e.printStackTrace();
			return null;
		}finally{
			if(Constants.OK == map.get("msgCode")) {

			}else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobilePushController selectPushCountCheck END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

}